// wrappointers.cpp
// This file is generated by Shroud nowrite-version. Do not edit.
// Copyright (c) 2017-2022, Lawrence Livermore National Security, LLC and
// other Shroud Project Developers.
// See the top-level COPYRIGHT file for details.
//
// SPDX-License-Identifier: (BSD-3-Clause)
//

// cxx_header
#include "pointers.h"
// shroud
#include <cstdlib>
#include <cstring>
#include "wrappointers.h"

// splicer begin CXX_definitions
// splicer end CXX_definitions

extern "C" {


// helper ShroudLenTrim
// Returns the length of character string src with length nsrc,
// ignoring any trailing blanks.
static int ShroudLenTrim(const char *src, int nsrc) {
    int i;

    for (i = nsrc - 1; i >= 0; i--) {
        if (src[i] != ' ') {
            break;
        }
    }

    return i + 1;
}


// helper ShroudStrArrayAlloc
// Copy src into new memory and null terminate.
// char **src +size(nsrc) +len(len)
// CHARACTER(len) src(nsrc)
static char **ShroudStrArrayAlloc(const char *src, int nsrc, int len)
{
   char **rv = static_cast<char **>(std::malloc(sizeof(char *) * nsrc));
   const char *src0 = src;
   for(int i=0; i < nsrc; ++i) {
      int ntrim = ShroudLenTrim(src0, len);
      char *tgt = static_cast<char *>(std::malloc(ntrim+1));
      std::memcpy(tgt, src0, ntrim);
      tgt[ntrim] = '\0';
      rv[i] = tgt;
      src0 += len;
   }
   return rv;
}

// helper ShroudStrArrayFree
// Release memory allocated by ShroudStrArrayAlloc
static void ShroudStrArrayFree(char **src, int nsrc)
{
   for(int i=0; i < nsrc; ++i) {
       std::free(src[i]);
   }
   std::free(src);
}
// splicer begin C_definitions
// splicer end C_definitions

// ----------------------------------------
// Function:  void intargs_in
// Attrs:     +intent(subroutine)
// Exact:     c_subroutine
// ----------------------------------------
// Argument:  const int * arg
// Attrs:     +intent(in)
// Requested: c_in_native_*
// Match:     c_default
// start POI_intargs_in
void POI_intargs_in(const int * arg)
{
    // splicer begin function.intargs_in
    intargs_in(arg);
    // splicer end function.intargs_in
}
// end POI_intargs_in

/**
 * Argument is modified by library, defaults to intent(inout).
 */
// ----------------------------------------
// Function:  void intargs_inout
// Attrs:     +intent(subroutine)
// Exact:     c_subroutine
// ----------------------------------------
// Argument:  int * arg
// Attrs:     +intent(inout)
// Requested: c_inout_native_*
// Match:     c_default
// start POI_intargs_inout
void POI_intargs_inout(int * arg)
{
    // splicer begin function.intargs_inout
    intargs_inout(arg);
    // splicer end function.intargs_inout
}
// end POI_intargs_inout

// ----------------------------------------
// Function:  void intargs_out
// Attrs:     +intent(subroutine)
// Exact:     c_subroutine
// ----------------------------------------
// Argument:  int * arg +intent(out)
// Attrs:     +intent(out)
// Requested: c_out_native_*
// Match:     c_default
// start POI_intargs_out
void POI_intargs_out(int * arg)
{
    // splicer begin function.intargs_out
    intargs_out(arg);
    // splicer end function.intargs_out
}
// end POI_intargs_out

// ----------------------------------------
// Function:  void intargs
// Attrs:     +intent(subroutine)
// Exact:     c_subroutine
// ----------------------------------------
// Argument:  const int argin +intent(in)+value
// Attrs:     +intent(in)
// Requested: c_in_native_scalar
// Match:     c_default
// ----------------------------------------
// Argument:  int * arginout +intent(inout)
// Attrs:     +intent(inout)
// Requested: c_inout_native_*
// Match:     c_default
// ----------------------------------------
// Argument:  int * argout +intent(out)
// Attrs:     +intent(out)
// Requested: c_out_native_*
// Match:     c_default
// start POI_intargs
void POI_intargs(const int argin, int * arginout, int * argout)
{
    // splicer begin function.intargs
    intargs(argin, arginout, argout);
    // splicer end function.intargs
}
// end POI_intargs

/**
 * \brief compute cos of IN and save in OUT
 *
 * allocate OUT same type as IN implied size of array
 */
// ----------------------------------------
// Function:  void cos_doubles
// Attrs:     +intent(subroutine)
// Exact:     c_subroutine
// ----------------------------------------
// Argument:  double * in +intent(in)+rank(1)
// Attrs:     +intent(in)
// Requested: c_in_native_*
// Match:     c_default
// ----------------------------------------
// Argument:  double * out +dimension(size(in))+intent(out)
// Attrs:     +intent(out)
// Requested: c_out_native_*
// Match:     c_default
// ----------------------------------------
// Argument:  int sizein +implied(size(in))+value
// Attrs:     +intent(in)
// Requested: c_in_native_scalar
// Match:     c_default
// start POI_cos_doubles
void POI_cos_doubles(double * in, double * out, int sizein)
{
    // splicer begin function.cos_doubles
    cos_doubles(in, out, sizein);
    // splicer end function.cos_doubles
}
// end POI_cos_doubles

/**
 * \brief truncate IN argument and save in OUT
 *
 * allocate OUT different type as IN
 * implied size of array
 */
// ----------------------------------------
// Function:  void truncate_to_int
// Attrs:     +intent(subroutine)
// Exact:     c_subroutine
// ----------------------------------------
// Argument:  double * in +intent(in)+rank(1)
// Attrs:     +intent(in)
// Requested: c_in_native_*
// Match:     c_default
// ----------------------------------------
// Argument:  int * out +dimension(size(in))+intent(out)
// Attrs:     +intent(out)
// Requested: c_out_native_*
// Match:     c_default
// ----------------------------------------
// Argument:  int sizein +implied(size(in))+value
// Attrs:     +intent(in)
// Requested: c_in_native_scalar
// Match:     c_default
// start POI_truncate_to_int
void POI_truncate_to_int(double * in, int * out, int sizein)
{
    // splicer begin function.truncate_to_int
    truncate_to_int(in, out, sizein);
    // splicer end function.truncate_to_int
}
// end POI_truncate_to_int

/**
 * \brief fill values into array
 *
 * The function knows how long the array must be.
 * Fortran will treat the dimension as assumed-length.
 * The Python wrapper will create a NumPy array or list so it must
 * have an explicit dimension (not assumed-length).
 */
// ----------------------------------------
// Function:  void get_values
// Attrs:     +intent(subroutine)
// Exact:     c_subroutine
// ----------------------------------------
// Argument:  int * nvalues +intent(OUT)
// Attrs:     +intent(out)
// Requested: c_out_native_*
// Match:     c_default
// ----------------------------------------
// Argument:  int * values +dimension(3)+intent(out)
// Attrs:     +intent(out)
// Requested: c_out_native_*
// Match:     c_default
// start POI_get_values
void POI_get_values(int * nvalues, int * values)
{
    // splicer begin function.get_values
    get_values(nvalues, values);
    // splicer end function.get_values
}
// end POI_get_values

/**
 * \brief fill values into two arrays
 *
 * Test two intent(out) arguments.
 * Make sure error handling works with C++.
 */
// ----------------------------------------
// Function:  void get_values2
// Attrs:     +intent(subroutine)
// Exact:     c_subroutine
// ----------------------------------------
// Argument:  int * arg1 +dimension(3)+intent(out)
// Attrs:     +intent(out)
// Requested: c_out_native_*
// Match:     c_default
// ----------------------------------------
// Argument:  int * arg2 +dimension(3)+intent(out)
// Attrs:     +intent(out)
// Requested: c_out_native_*
// Match:     c_default
// start POI_get_values2
void POI_get_values2(int * arg1, int * arg2)
{
    // splicer begin function.get_values2
    get_values2(arg1, arg2);
    // splicer end function.get_values2
}
// end POI_get_values2

// ----------------------------------------
// Function:  void iota_dimension
// Attrs:     +intent(subroutine)
// Exact:     c_subroutine
// ----------------------------------------
// Argument:  int nvar +value
// Attrs:     +intent(in)
// Requested: c_in_native_scalar
// Match:     c_default
// ----------------------------------------
// Argument:  int * values +dimension(nvar)+intent(out)
// Attrs:     +intent(out)
// Requested: c_out_native_*
// Match:     c_default
// start POI_iota_dimension
void POI_iota_dimension(int nvar, int * values)
{
    // splicer begin function.iota_dimension
    iota_dimension(nvar, values);
    // splicer end function.iota_dimension
}
// end POI_iota_dimension

// ----------------------------------------
// Function:  void Sum
// Attrs:     +intent(subroutine)
// Exact:     c_subroutine
// ----------------------------------------
// Argument:  int len +implied(size(values))+value
// Attrs:     +intent(in)
// Requested: c_in_native_scalar
// Match:     c_default
// ----------------------------------------
// Argument:  const int * values +rank(1)
// Attrs:     +intent(in)
// Requested: c_in_native_*
// Match:     c_default
// ----------------------------------------
// Argument:  int * result +intent(out)
// Attrs:     +intent(out)
// Requested: c_out_native_*
// Match:     c_default
// start POI_sum
void POI_sum(int len, const int * values, int * result)
{
    // splicer begin function.sum
    Sum(len, values, result);
    // splicer end function.sum
}
// end POI_sum

/**
 * Return three values into memory the user provides.
 */
// ----------------------------------------
// Function:  void fillIntArray
// Attrs:     +intent(subroutine)
// Exact:     c_subroutine
// ----------------------------------------
// Argument:  int * out +dimension(3)+intent(out)
// Attrs:     +intent(out)
// Requested: c_out_native_*
// Match:     c_default
// start POI_fill_int_array
void POI_fill_int_array(int * out)
{
    // splicer begin function.fill_int_array
    fillIntArray(out);
    // splicer end function.fill_int_array
}
// end POI_fill_int_array

/**
 * Increment array in place using intent(INOUT).
 */
// ----------------------------------------
// Function:  void incrementIntArray
// Attrs:     +intent(subroutine)
// Exact:     c_subroutine
// ----------------------------------------
// Argument:  int * array +intent(inout)+rank(1)
// Attrs:     +intent(inout)
// Requested: c_inout_native_*
// Match:     c_default
// ----------------------------------------
// Argument:  int sizein +implied(size(array))+value
// Attrs:     +intent(in)
// Requested: c_in_native_scalar
// Match:     c_default
// start POI_increment_int_array
void POI_increment_int_array(int * array, int sizein)
{
    // splicer begin function.increment_int_array
    incrementIntArray(array, sizein);
    // splicer end function.increment_int_array
}
// end POI_increment_int_array

// ----------------------------------------
// Function:  void fill_with_zeros
// Attrs:     +intent(subroutine)
// Exact:     c_subroutine
// ----------------------------------------
// Argument:  double * x +rank(1)
// Attrs:     +intent(inout)
// Requested: c_inout_native_*
// Match:     c_default
// ----------------------------------------
// Argument:  int x_length +implied(size(x))+value
// Attrs:     +intent(in)
// Requested: c_in_native_scalar
// Match:     c_default
// start POI_fill_with_zeros
void POI_fill_with_zeros(double * x, int x_length)
{
    // splicer begin function.fill_with_zeros
    fill_with_zeros(x, x_length);
    // splicer end function.fill_with_zeros
}
// end POI_fill_with_zeros

// ----------------------------------------
// Function:  int accumulate
// Attrs:     +intent(function)
// Requested: c_function_native_scalar
// Match:     c_function
// ----------------------------------------
// Argument:  const int * arr +rank(1)
// Attrs:     +intent(in)
// Requested: c_in_native_*
// Match:     c_default
// ----------------------------------------
// Argument:  size_t len +implied(size(arr))+value
// Attrs:     +intent(in)
// Requested: c_in_native_scalar
// Match:     c_default
// start POI_accumulate
int POI_accumulate(const int * arr, size_t len)
{
    // splicer begin function.accumulate
    int SHC_rv = accumulate(arr, len);
    return SHC_rv;
    // splicer end function.accumulate
}
// end POI_accumulate

/**
 * Return strlen of the first index as a check.
 */
// ----------------------------------------
// Function:  int acceptCharArrayIn
// Attrs:     +intent(function)
// Requested: c_function_native_scalar
// Match:     c_function
// ----------------------------------------
// Argument:  char * * names +intent(in)+rank(1)
// Attrs:     +intent(in)
// Exact:     c_in_char_**
// start POI_accept_char_array_in
int POI_accept_char_array_in(char **names)
{
    // splicer begin function.accept_char_array_in
    int SHC_rv = acceptCharArrayIn(names);
    return SHC_rv;
    // splicer end function.accept_char_array_in
}
// end POI_accept_char_array_in

/**
 * Return strlen of the first index as a check.
 */
// ----------------------------------------
// Function:  int acceptCharArrayIn
// Attrs:     +intent(function)
// Requested: c_function_native_scalar
// Match:     c_function
// ----------------------------------------
// Argument:  char * * names +intent(in)+rank(1)
// Attrs:     +api(buf)+intent(in)
// Exact:     c_in_char_**_buf
// start POI_accept_char_array_in_bufferify
int POI_accept_char_array_in_bufferify(const char *names,
    size_t SHT_names_size, int SHT_names_len)
{
    // splicer begin function.accept_char_array_in_bufferify
    char **SHCXX_names = ShroudStrArrayAlloc(names, SHT_names_size,
        SHT_names_len);
    int SHC_rv = acceptCharArrayIn(SHCXX_names);
    ShroudStrArrayFree(SHCXX_names, SHT_names_size);
    return SHC_rv;
    // splicer end function.accept_char_array_in_bufferify
}
// end POI_accept_char_array_in_bufferify

// ----------------------------------------
// Function:  void setGlobalInt
// Attrs:     +intent(subroutine)
// Exact:     c_subroutine
// ----------------------------------------
// Argument:  int value +value
// Attrs:     +intent(in)
// Requested: c_in_native_scalar
// Match:     c_default
// start POI_set_global_int
void POI_set_global_int(int value)
{
    // splicer begin function.set_global_int
    setGlobalInt(value);
    // splicer end function.set_global_int
}
// end POI_set_global_int

/**
 * Used to test values global_array.
 */
// ----------------------------------------
// Function:  int sumFixedArray
// Attrs:     +intent(function)
// Requested: c_function_native_scalar
// Match:     c_function
// start POI_sum_fixed_array
int POI_sum_fixed_array(void)
{
    // splicer begin function.sum_fixed_array
    int SHC_rv = sumFixedArray();
    return SHC_rv;
    // splicer end function.sum_fixed_array
}
// end POI_sum_fixed_array

// ----------------------------------------
// Function:  void getPtrToScalar
// Attrs:     +intent(subroutine)
// Exact:     c_subroutine
// ----------------------------------------
// Argument:  int * * nitems +intent(out)
// Attrs:     +deref(pointer)+intent(out)
// Requested: c_out_native_**_pointer
// Match:     c_default
// start POI_get_ptr_to_scalar
void POI_get_ptr_to_scalar(int * * nitems)
{
    // splicer begin function.get_ptr_to_scalar
    getPtrToScalar(nitems);
    // splicer end function.get_ptr_to_scalar
}
// end POI_get_ptr_to_scalar

// ----------------------------------------
// Function:  void getPtrToScalar
// Attrs:     +intent(subroutine)
// Exact:     c_subroutine
// ----------------------------------------
// Argument:  int * * nitems +intent(out)
// Attrs:     +api(cdesc)+deref(pointer)+intent(out)
// Requested: c_out_native_**_cdesc_pointer
// Match:     c_out_native_**_cdesc
// start POI_get_ptr_to_scalar_bufferify
void POI_get_ptr_to_scalar_bufferify(POI_SHROUD_array *SHT_nitems_cdesc)
{
    // splicer begin function.get_ptr_to_scalar_bufferify
    int *nitems;
    getPtrToScalar(&nitems);
    SHT_nitems_cdesc->cxx.addr  = nitems;
    SHT_nitems_cdesc->cxx.idtor = 0;
    SHT_nitems_cdesc->addr.base = nitems;
    SHT_nitems_cdesc->type = SH_TYPE_INT;
    SHT_nitems_cdesc->elem_len = sizeof(int);
    SHT_nitems_cdesc->rank = 0;
    SHT_nitems_cdesc->size = 1;
    // splicer end function.get_ptr_to_scalar_bufferify
}
// end POI_get_ptr_to_scalar_bufferify

/**
 * Return a Fortran pointer to an array which is always the same length.
 */
// ----------------------------------------
// Function:  void getPtrToFixedArray
// Attrs:     +intent(subroutine)
// Exact:     c_subroutine
// ----------------------------------------
// Argument:  int * * count +dimension(10)+intent(out)
// Attrs:     +deref(pointer)+intent(out)
// Requested: c_out_native_**_pointer
// Match:     c_default
// start POI_get_ptr_to_fixed_array
void POI_get_ptr_to_fixed_array(int * * count)
{
    // splicer begin function.get_ptr_to_fixed_array
    getPtrToFixedArray(count);
    // splicer end function.get_ptr_to_fixed_array
}
// end POI_get_ptr_to_fixed_array

/**
 * Return a Fortran pointer to an array which is always the same length.
 */
// ----------------------------------------
// Function:  void getPtrToFixedArray
// Attrs:     +intent(subroutine)
// Exact:     c_subroutine
// ----------------------------------------
// Argument:  int * * count +dimension(10)+intent(out)
// Attrs:     +api(cdesc)+deref(pointer)+intent(out)
// Requested: c_out_native_**_cdesc_pointer
// Match:     c_out_native_**_cdesc
// start POI_get_ptr_to_fixed_array_bufferify
void POI_get_ptr_to_fixed_array_bufferify(
    POI_SHROUD_array *SHT_count_cdesc)
{
    // splicer begin function.get_ptr_to_fixed_array_bufferify
    int *count;
    getPtrToFixedArray(&count);
    SHT_count_cdesc->cxx.addr  = count;
    SHT_count_cdesc->cxx.idtor = 0;
    SHT_count_cdesc->addr.base = count;
    SHT_count_cdesc->type = SH_TYPE_INT;
    SHT_count_cdesc->elem_len = sizeof(int);
    SHT_count_cdesc->rank = 1;
    SHT_count_cdesc->shape[0] = 10;
    SHT_count_cdesc->size = SHT_count_cdesc->shape[0];
    // splicer end function.get_ptr_to_fixed_array_bufferify
}
// end POI_get_ptr_to_fixed_array_bufferify

/**
 * Return a Fortran pointer to an array which is the length of
 * the argument ncount.
 */
// ----------------------------------------
// Function:  void getPtrToDynamicArray
// Attrs:     +intent(subroutine)
// Exact:     c_subroutine
// ----------------------------------------
// Argument:  int * * count +dimension(ncount)+intent(out)
// Attrs:     +deref(pointer)+intent(out)
// Requested: c_out_native_**_pointer
// Match:     c_default
// ----------------------------------------
// Argument:  int * ncount +hidden+intent(out)
// Attrs:     +intent(out)
// Requested: c_out_native_*
// Match:     c_default
// start POI_get_ptr_to_dynamic_array
void POI_get_ptr_to_dynamic_array(int * * count, int * ncount)
{
    // splicer begin function.get_ptr_to_dynamic_array
    getPtrToDynamicArray(count, ncount);
    // splicer end function.get_ptr_to_dynamic_array
}
// end POI_get_ptr_to_dynamic_array

/**
 * Return a Fortran pointer to an array which is the length of
 * the argument ncount.
 */
// ----------------------------------------
// Function:  void getPtrToDynamicArray
// Attrs:     +intent(subroutine)
// Exact:     c_subroutine
// ----------------------------------------
// Argument:  int * * count +dimension(ncount)+intent(out)
// Attrs:     +api(cdesc)+deref(pointer)+intent(out)
// Requested: c_out_native_**_cdesc_pointer
// Match:     c_out_native_**_cdesc
// ----------------------------------------
// Argument:  int * ncount +hidden+intent(out)
// Attrs:     +intent(out)
// Exact:     c_out_native_*_hidden
// start POI_get_ptr_to_dynamic_array_bufferify
void POI_get_ptr_to_dynamic_array_bufferify(
    POI_SHROUD_array *SHT_count_cdesc)
{
    // splicer begin function.get_ptr_to_dynamic_array_bufferify
    int *count;
    int ncount;
    getPtrToDynamicArray(&count, &ncount);
    SHT_count_cdesc->cxx.addr  = count;
    SHT_count_cdesc->cxx.idtor = 0;
    SHT_count_cdesc->addr.base = count;
    SHT_count_cdesc->type = SH_TYPE_INT;
    SHT_count_cdesc->elem_len = sizeof(int);
    SHT_count_cdesc->rank = 1;
    SHT_count_cdesc->shape[0] = ncount;
    SHT_count_cdesc->size = SHT_count_cdesc->shape[0];
    // splicer end function.get_ptr_to_dynamic_array_bufferify
}
// end POI_get_ptr_to_dynamic_array_bufferify

/**
 * Return a Fortran pointer to an array which is the length
 * is computed by C++ function getLen.
 * getLen will be called from C/C++ to compute the shape.
 */
// ----------------------------------------
// Function:  void getPtrToFuncArray
// Attrs:     +intent(subroutine)
// Exact:     c_subroutine
// ----------------------------------------
// Argument:  int * * count +dimension(getLen())+intent(out)
// Attrs:     +deref(pointer)+intent(out)
// Requested: c_out_native_**_pointer
// Match:     c_default
// start POI_get_ptr_to_func_array
void POI_get_ptr_to_func_array(int * * count)
{
    // splicer begin function.get_ptr_to_func_array
    getPtrToFuncArray(count);
    // splicer end function.get_ptr_to_func_array
}
// end POI_get_ptr_to_func_array

/**
 * Return a Fortran pointer to an array which is the length
 * is computed by C++ function getLen.
 * getLen will be called from C/C++ to compute the shape.
 */
// ----------------------------------------
// Function:  void getPtrToFuncArray
// Attrs:     +intent(subroutine)
// Exact:     c_subroutine
// ----------------------------------------
// Argument:  int * * count +dimension(getLen())+intent(out)
// Attrs:     +api(cdesc)+deref(pointer)+intent(out)
// Requested: c_out_native_**_cdesc_pointer
// Match:     c_out_native_**_cdesc
// start POI_get_ptr_to_func_array_bufferify
void POI_get_ptr_to_func_array_bufferify(
    POI_SHROUD_array *SHT_count_cdesc)
{
    // splicer begin function.get_ptr_to_func_array_bufferify
    int *count;
    getPtrToFuncArray(&count);
    SHT_count_cdesc->cxx.addr  = count;
    SHT_count_cdesc->cxx.idtor = 0;
    SHT_count_cdesc->addr.base = count;
    SHT_count_cdesc->type = SH_TYPE_INT;
    SHT_count_cdesc->elem_len = sizeof(int);
    SHT_count_cdesc->rank = 1;
    SHT_count_cdesc->shape[0] = getLen();
    SHT_count_cdesc->size = SHT_count_cdesc->shape[0];
    // splicer end function.get_ptr_to_func_array_bufferify
}
// end POI_get_ptr_to_func_array_bufferify

// ----------------------------------------
// Function:  void getPtrToConstScalar
// Attrs:     +intent(subroutine)
// Exact:     c_subroutine
// ----------------------------------------
// Argument:  const int * * nitems +intent(out)
// Attrs:     +deref(pointer)+intent(out)
// Requested: c_out_native_**_pointer
// Match:     c_default
// start POI_get_ptr_to_const_scalar
void POI_get_ptr_to_const_scalar(const int * * nitems)
{
    // splicer begin function.get_ptr_to_const_scalar
    getPtrToConstScalar(nitems);
    // splicer end function.get_ptr_to_const_scalar
}
// end POI_get_ptr_to_const_scalar

// ----------------------------------------
// Function:  void getPtrToConstScalar
// Attrs:     +intent(subroutine)
// Exact:     c_subroutine
// ----------------------------------------
// Argument:  const int * * nitems +intent(out)
// Attrs:     +api(cdesc)+deref(pointer)+intent(out)
// Requested: c_out_native_**_cdesc_pointer
// Match:     c_out_native_**_cdesc
// start POI_get_ptr_to_const_scalar_bufferify
void POI_get_ptr_to_const_scalar_bufferify(
    POI_SHROUD_array *SHT_nitems_cdesc)
{
    // splicer begin function.get_ptr_to_const_scalar_bufferify
    const int *nitems;
    getPtrToConstScalar(&nitems);
    SHT_nitems_cdesc->cxx.addr  = const_cast<int *>(nitems);
    SHT_nitems_cdesc->cxx.idtor = 0;
    SHT_nitems_cdesc->addr.base = nitems;
    SHT_nitems_cdesc->type = SH_TYPE_INT;
    SHT_nitems_cdesc->elem_len = sizeof(int);
    SHT_nitems_cdesc->rank = 0;
    SHT_nitems_cdesc->size = 1;
    // splicer end function.get_ptr_to_const_scalar_bufferify
}
// end POI_get_ptr_to_const_scalar_bufferify

// ----------------------------------------
// Function:  void getPtrToFixedConstArray
// Attrs:     +intent(subroutine)
// Exact:     c_subroutine
// ----------------------------------------
// Argument:  const int * * count +dimension(10)+intent(out)
// Attrs:     +deref(pointer)+intent(out)
// Requested: c_out_native_**_pointer
// Match:     c_default
// start POI_get_ptr_to_fixed_const_array
void POI_get_ptr_to_fixed_const_array(const int * * count)
{
    // splicer begin function.get_ptr_to_fixed_const_array
    getPtrToFixedConstArray(count);
    // splicer end function.get_ptr_to_fixed_const_array
}
// end POI_get_ptr_to_fixed_const_array

// ----------------------------------------
// Function:  void getPtrToFixedConstArray
// Attrs:     +intent(subroutine)
// Exact:     c_subroutine
// ----------------------------------------
// Argument:  const int * * count +dimension(10)+intent(out)
// Attrs:     +api(cdesc)+deref(pointer)+intent(out)
// Requested: c_out_native_**_cdesc_pointer
// Match:     c_out_native_**_cdesc
// start POI_get_ptr_to_fixed_const_array_bufferify
void POI_get_ptr_to_fixed_const_array_bufferify(
    POI_SHROUD_array *SHT_count_cdesc)
{
    // splicer begin function.get_ptr_to_fixed_const_array_bufferify
    const int *count;
    getPtrToFixedConstArray(&count);
    SHT_count_cdesc->cxx.addr  = const_cast<int *>(count);
    SHT_count_cdesc->cxx.idtor = 0;
    SHT_count_cdesc->addr.base = count;
    SHT_count_cdesc->type = SH_TYPE_INT;
    SHT_count_cdesc->elem_len = sizeof(int);
    SHT_count_cdesc->rank = 1;
    SHT_count_cdesc->shape[0] = 10;
    SHT_count_cdesc->size = SHT_count_cdesc->shape[0];
    // splicer end function.get_ptr_to_fixed_const_array_bufferify
}
// end POI_get_ptr_to_fixed_const_array_bufferify

// ----------------------------------------
// Function:  void getPtrToDynamicConstArray
// Attrs:     +intent(subroutine)
// Exact:     c_subroutine
// ----------------------------------------
// Argument:  const int * * count +dimension(ncount)+intent(out)
// Attrs:     +deref(pointer)+intent(out)
// Requested: c_out_native_**_pointer
// Match:     c_default
// ----------------------------------------
// Argument:  int * ncount +hidden+intent(out)
// Attrs:     +intent(out)
// Requested: c_out_native_*
// Match:     c_default
// start POI_get_ptr_to_dynamic_const_array
void POI_get_ptr_to_dynamic_const_array(const int * * count,
    int * ncount)
{
    // splicer begin function.get_ptr_to_dynamic_const_array
    getPtrToDynamicConstArray(count, ncount);
    // splicer end function.get_ptr_to_dynamic_const_array
}
// end POI_get_ptr_to_dynamic_const_array

// ----------------------------------------
// Function:  void getPtrToDynamicConstArray
// Attrs:     +intent(subroutine)
// Exact:     c_subroutine
// ----------------------------------------
// Argument:  const int * * count +dimension(ncount)+intent(out)
// Attrs:     +api(cdesc)+deref(pointer)+intent(out)
// Requested: c_out_native_**_cdesc_pointer
// Match:     c_out_native_**_cdesc
// ----------------------------------------
// Argument:  int * ncount +hidden+intent(out)
// Attrs:     +intent(out)
// Exact:     c_out_native_*_hidden
// start POI_get_ptr_to_dynamic_const_array_bufferify
void POI_get_ptr_to_dynamic_const_array_bufferify(
    POI_SHROUD_array *SHT_count_cdesc)
{
    // splicer begin function.get_ptr_to_dynamic_const_array_bufferify
    const int *count;
    int ncount;
    getPtrToDynamicConstArray(&count, &ncount);
    SHT_count_cdesc->cxx.addr  = const_cast<int *>(count);
    SHT_count_cdesc->cxx.idtor = 0;
    SHT_count_cdesc->addr.base = count;
    SHT_count_cdesc->type = SH_TYPE_INT;
    SHT_count_cdesc->elem_len = sizeof(int);
    SHT_count_cdesc->rank = 1;
    SHT_count_cdesc->shape[0] = ncount;
    SHT_count_cdesc->size = SHT_count_cdesc->shape[0];
    // splicer end function.get_ptr_to_dynamic_const_array_bufferify
}
// end POI_get_ptr_to_dynamic_const_array_bufferify

/**
 * Called directly via an interface in Fortran.
 */
// ----------------------------------------
// Function:  void getRawPtrToScalar
// Attrs:     +intent(subroutine)
// Exact:     c_subroutine
// ----------------------------------------
// Argument:  int * * nitems +deref(raw)+intent(out)
// Attrs:     +deref(raw)+intent(out)
// Requested: c_out_native_**_raw
// Match:     c_default
// start POI_get_raw_ptr_to_scalar
void POI_get_raw_ptr_to_scalar(int * * nitems)
{
    // splicer begin function.get_raw_ptr_to_scalar
    getRawPtrToScalar(nitems);
    // splicer end function.get_raw_ptr_to_scalar
}
// end POI_get_raw_ptr_to_scalar

/**
 * Create a Fortran wrapper.
 */
// ----------------------------------------
// Function:  void getRawPtrToScalarForce
// Attrs:     +intent(subroutine)
// Exact:     c_subroutine
// ----------------------------------------
// Argument:  int * * nitems +deref(raw)+intent(out)
// Attrs:     +deref(raw)+intent(out)
// Requested: c_out_native_**_raw
// Match:     c_default
// start POI_get_raw_ptr_to_scalar_force
void POI_get_raw_ptr_to_scalar_force(int * * nitems)
{
    // splicer begin function.get_raw_ptr_to_scalar_force
    getRawPtrToScalarForce(nitems);
    // splicer end function.get_raw_ptr_to_scalar_force
}
// end POI_get_raw_ptr_to_scalar_force

/**
 * Return a type(C_PTR) to an array which is always the same length.
 * Called directly via an interface in Fortran.
 * # Uses +deref(raw) instead of +dimension(10) like getPtrToFixedArray.
 */
// ----------------------------------------
// Function:  void getRawPtrToFixedArray
// Attrs:     +intent(subroutine)
// Exact:     c_subroutine
// ----------------------------------------
// Argument:  int * * count +deref(raw)+intent(out)
// Attrs:     +deref(raw)+intent(out)
// Requested: c_out_native_**_raw
// Match:     c_default
// start POI_get_raw_ptr_to_fixed_array
void POI_get_raw_ptr_to_fixed_array(int * * count)
{
    // splicer begin function.get_raw_ptr_to_fixed_array
    getRawPtrToFixedArray(count);
    // splicer end function.get_raw_ptr_to_fixed_array
}
// end POI_get_raw_ptr_to_fixed_array

/**
 * Return a type(C_PTR) to an array which is always the same length.
 * Create a Fortran wrapper.
 */
// ----------------------------------------
// Function:  void getRawPtrToFixedArrayForce
// Attrs:     +intent(subroutine)
// Exact:     c_subroutine
// ----------------------------------------
// Argument:  int * * count +deref(raw)+intent(out)
// Attrs:     +deref(raw)+intent(out)
// Requested: c_out_native_**_raw
// Match:     c_default
// start POI_get_raw_ptr_to_fixed_array_force
void POI_get_raw_ptr_to_fixed_array_force(int * * count)
{
    // splicer begin function.get_raw_ptr_to_fixed_array_force
    getRawPtrToFixedArrayForce(count);
    // splicer end function.get_raw_ptr_to_fixed_array_force
}
// end POI_get_raw_ptr_to_fixed_array_force

/**
 * Test multiple layers of indirection.
 */
// ----------------------------------------
// Function:  void getRawPtrToInt2d
// Attrs:     +intent(subroutine)
// Exact:     c_subroutine
// ----------------------------------------
// Argument:  int * * * arg +intent(out)
// Attrs:     +intent(out)
// Requested: c_out_native_***
// Match:     c_default
// start POI_get_raw_ptr_to_int2d
void POI_get_raw_ptr_to_int2d(int * * * arg)
{
    // splicer begin function.get_raw_ptr_to_int2d
    getRawPtrToInt2d(arg);
    // splicer end function.get_raw_ptr_to_int2d
}
// end POI_get_raw_ptr_to_int2d

/**
 * Check results of getRawPtrToInt2d.
 */
// ----------------------------------------
// Function:  int checkInt2d
// Attrs:     +intent(function)
// Requested: c_function_native_scalar
// Match:     c_function
// ----------------------------------------
// Argument:  int * * arg +intent(in)
// Attrs:     +intent(in)
// Exact:     c_in_native_**
// start POI_check_int2d
int POI_check_int2d(int **arg)
{
    // splicer begin function.check_int2d
    int SHC_rv = checkInt2d(arg);
    return SHC_rv;
    // splicer end function.check_int2d
}
// end POI_check_int2d

/**
 * Test +dimension(10,20) +intent(in) together.
 * This will not use assumed-shape in the Fortran wrapper.
 */
// ----------------------------------------
// Function:  void DimensionIn
// Attrs:     +intent(subroutine)
// Exact:     c_subroutine
// ----------------------------------------
// Argument:  const int * arg +dimension(10,20)
// Attrs:     +intent(in)
// Requested: c_in_native_*
// Match:     c_default
// start POI_dimension_in
void POI_dimension_in(const int * arg)
{
    // splicer begin function.dimension_in
    DimensionIn(arg);
    // splicer end function.dimension_in
}
// end POI_dimension_in

/**
 * Return a Fortran pointer to an array which is always the same length.
 */
// ----------------------------------------
// Function:  void getAllocToFixedArray
// Attrs:     +intent(subroutine)
// Exact:     c_subroutine
// ----------------------------------------
// Argument:  int * * count +deref(allocatable)+dimension(10)+intent(out)
// Attrs:     +deref(allocatable)+intent(out)
// Requested: c_out_native_**_allocatable
// Match:     c_default
// start POI_get_alloc_to_fixed_array
void POI_get_alloc_to_fixed_array(int * * count)
{
    // splicer begin function.get_alloc_to_fixed_array
    getAllocToFixedArray(count);
    // splicer end function.get_alloc_to_fixed_array
}
// end POI_get_alloc_to_fixed_array

/**
 * Return a Fortran pointer to an array which is always the same length.
 */
// ----------------------------------------
// Function:  void getAllocToFixedArray
// Attrs:     +intent(subroutine)
// Exact:     c_subroutine
// ----------------------------------------
// Argument:  int * * count +deref(allocatable)+dimension(10)+intent(out)
// Attrs:     +api(cdesc)+deref(allocatable)+intent(out)
// Requested: c_out_native_**_cdesc_allocatable
// Match:     c_out_native_**_cdesc
// start POI_get_alloc_to_fixed_array_bufferify
void POI_get_alloc_to_fixed_array_bufferify(
    POI_SHROUD_array *SHT_count_cdesc)
{
    // splicer begin function.get_alloc_to_fixed_array_bufferify
    int *count;
    getAllocToFixedArray(&count);
    SHT_count_cdesc->cxx.addr  = count;
    SHT_count_cdesc->cxx.idtor = 0;
    SHT_count_cdesc->addr.base = count;
    SHT_count_cdesc->type = SH_TYPE_INT;
    SHT_count_cdesc->elem_len = sizeof(int);
    SHT_count_cdesc->rank = 1;
    SHT_count_cdesc->shape[0] = 10;
    SHT_count_cdesc->size = SHT_count_cdesc->shape[0];
    // splicer end function.get_alloc_to_fixed_array_bufferify
}
// end POI_get_alloc_to_fixed_array_bufferify

// ----------------------------------------
// Function:  void * returnAddress1
// Attrs:     +intent(function)
// Requested: c_function_void_*
// Match:     c_function
// ----------------------------------------
// Argument:  int flag +value
// Attrs:     +intent(in)
// Requested: c_in_native_scalar
// Match:     c_default
// start POI_return_address1
void * POI_return_address1(int flag)
{
    // splicer begin function.return_address1
    void * SHC_rv = returnAddress1(flag);
    return SHC_rv;
    // splicer end function.return_address1
}
// end POI_return_address1

// ----------------------------------------
// Function:  void * returnAddress2
// Attrs:     +intent(function)
// Requested: c_function_void_*
// Match:     c_function
// ----------------------------------------
// Argument:  int flag +value
// Attrs:     +intent(in)
// Requested: c_in_native_scalar
// Match:     c_default
// start POI_return_address2
void * POI_return_address2(int flag)
{
    // splicer begin function.return_address2
    void * SHC_rv = returnAddress2(flag);
    return SHC_rv;
    // splicer end function.return_address2
}
// end POI_return_address2

// ----------------------------------------
// Function:  void fetchVoidPtr
// Attrs:     +intent(subroutine)
// Exact:     c_subroutine
// ----------------------------------------
// Argument:  void * * addr +intent(out)
// Attrs:     +intent(out)
// Exact:     c_out_void_**
// start POI_fetch_void_ptr
void POI_fetch_void_ptr(void **addr)
{
    // splicer begin function.fetch_void_ptr
    fetchVoidPtr(addr);
    // splicer end function.fetch_void_ptr
}
// end POI_fetch_void_ptr

// ----------------------------------------
// Function:  void updateVoidPtr
// Attrs:     +intent(subroutine)
// Exact:     c_subroutine
// ----------------------------------------
// Argument:  void * * addr +intent(inout)
// Attrs:     +intent(inout)
// Exact:     c_inout_void_**
// start POI_update_void_ptr
void POI_update_void_ptr(void **addr)
{
    // splicer begin function.update_void_ptr
    updateVoidPtr(addr);
    // splicer end function.update_void_ptr
}
// end POI_update_void_ptr

// ----------------------------------------
// Function:  int VoidPtrArray
// Attrs:     +intent(function)
// Requested: c_function_native_scalar
// Match:     c_function
// ----------------------------------------
// Argument:  void * * addr +rank(1)
// Attrs:     +intent(in)
// Exact:     c_in_void_**
// start POI_void_ptr_array
int POI_void_ptr_array(void **addr)
{
    // splicer begin function.void_ptr_array
    int SHC_rv = VoidPtrArray(addr);
    return SHC_rv;
    // splicer end function.void_ptr_array
}
// end POI_void_ptr_array

// ----------------------------------------
// Function:  int * returnIntPtrToScalar
// Attrs:     +deref(pointer)+intent(function)
// Requested: c_function_native_*_pointer
// Match:     c_function_native_*
// start POI_return_int_ptr_to_scalar
int * POI_return_int_ptr_to_scalar(void)
{
    // splicer begin function.return_int_ptr_to_scalar
    int * SHC_rv = returnIntPtrToScalar();
    return SHC_rv;
    // splicer end function.return_int_ptr_to_scalar
}
// end POI_return_int_ptr_to_scalar

// ----------------------------------------
// Function:  int * returnIntPtrToScalar
// Attrs:     +api(buf)+deref(pointer)+intent(function)
// Requested: c_function_native_*_buf_pointer
// Match:     c_function_native_*
// start POI_return_int_ptr_to_scalar_bufferify
int * POI_return_int_ptr_to_scalar_bufferify(void)
{
    // splicer begin function.return_int_ptr_to_scalar_bufferify
    int * SHC_rv = returnIntPtrToScalar();
    return SHC_rv;
    // splicer end function.return_int_ptr_to_scalar_bufferify
}
// end POI_return_int_ptr_to_scalar_bufferify

// ----------------------------------------
// Function:  int * returnIntPtrToFixedArray +dimension(10)
// Attrs:     +deref(pointer)+intent(function)
// Requested: c_function_native_*_pointer
// Match:     c_function_native_*
// start POI_return_int_ptr_to_fixed_array
int * POI_return_int_ptr_to_fixed_array(void)
{
    // splicer begin function.return_int_ptr_to_fixed_array
    int * SHC_rv = returnIntPtrToFixedArray();
    return SHC_rv;
    // splicer end function.return_int_ptr_to_fixed_array
}
// end POI_return_int_ptr_to_fixed_array

// ----------------------------------------
// Function:  int * returnIntPtrToFixedArray +dimension(10)
// Attrs:     +api(cdesc)+deref(pointer)+intent(function)
// Requested: c_function_native_*_cdesc_pointer
// Match:     c_function_native_*_cdesc
// start POI_return_int_ptr_to_fixed_array_bufferify
void POI_return_int_ptr_to_fixed_array_bufferify(
    POI_SHROUD_array *SHT_rv_cdesc)
{
    // splicer begin function.return_int_ptr_to_fixed_array_bufferify
    int * SHC_rv = returnIntPtrToFixedArray();
    SHT_rv_cdesc->cxx.addr  = SHC_rv;
    SHT_rv_cdesc->cxx.idtor = 0;
    SHT_rv_cdesc->addr.base = SHC_rv;
    SHT_rv_cdesc->type = SH_TYPE_INT;
    SHT_rv_cdesc->elem_len = sizeof(int);
    SHT_rv_cdesc->rank = 1;
    SHT_rv_cdesc->shape[0] = 10;
    SHT_rv_cdesc->size = SHT_rv_cdesc->shape[0];
    // splicer end function.return_int_ptr_to_fixed_array_bufferify
}
// end POI_return_int_ptr_to_fixed_array_bufferify

// ----------------------------------------
// Function:  const int * returnIntPtrToConstScalar
// Attrs:     +deref(pointer)+intent(function)
// Requested: c_function_native_*_pointer
// Match:     c_function_native_*
// start POI_return_int_ptr_to_const_scalar
const int * POI_return_int_ptr_to_const_scalar(void)
{
    // splicer begin function.return_int_ptr_to_const_scalar
    const int * SHC_rv = returnIntPtrToConstScalar();
    return SHC_rv;
    // splicer end function.return_int_ptr_to_const_scalar
}
// end POI_return_int_ptr_to_const_scalar

// ----------------------------------------
// Function:  const int * returnIntPtrToConstScalar
// Attrs:     +api(buf)+deref(pointer)+intent(function)
// Requested: c_function_native_*_buf_pointer
// Match:     c_function_native_*
// start POI_return_int_ptr_to_const_scalar_bufferify
const int * POI_return_int_ptr_to_const_scalar_bufferify(void)
{
    // splicer begin function.return_int_ptr_to_const_scalar_bufferify
    const int * SHC_rv = returnIntPtrToConstScalar();
    return SHC_rv;
    // splicer end function.return_int_ptr_to_const_scalar_bufferify
}
// end POI_return_int_ptr_to_const_scalar_bufferify

// ----------------------------------------
// Function:  const int * returnIntPtrToFixedConstArray +dimension(10)
// Attrs:     +deref(pointer)+intent(function)
// Requested: c_function_native_*_pointer
// Match:     c_function_native_*
// start POI_return_int_ptr_to_fixed_const_array
const int * POI_return_int_ptr_to_fixed_const_array(void)
{
    // splicer begin function.return_int_ptr_to_fixed_const_array
    const int * SHC_rv = returnIntPtrToFixedConstArray();
    return SHC_rv;
    // splicer end function.return_int_ptr_to_fixed_const_array
}
// end POI_return_int_ptr_to_fixed_const_array

// ----------------------------------------
// Function:  const int * returnIntPtrToFixedConstArray +dimension(10)
// Attrs:     +api(cdesc)+deref(pointer)+intent(function)
// Requested: c_function_native_*_cdesc_pointer
// Match:     c_function_native_*_cdesc
// start POI_return_int_ptr_to_fixed_const_array_bufferify
void POI_return_int_ptr_to_fixed_const_array_bufferify(
    POI_SHROUD_array *SHT_rv_cdesc)
{
    // splicer begin function.return_int_ptr_to_fixed_const_array_bufferify
    const int * SHC_rv = returnIntPtrToFixedConstArray();
    SHT_rv_cdesc->cxx.addr  = const_cast<int *>(SHC_rv);
    SHT_rv_cdesc->cxx.idtor = 0;
    SHT_rv_cdesc->addr.base = SHC_rv;
    SHT_rv_cdesc->type = SH_TYPE_INT;
    SHT_rv_cdesc->elem_len = sizeof(int);
    SHT_rv_cdesc->rank = 1;
    SHT_rv_cdesc->shape[0] = 10;
    SHT_rv_cdesc->size = SHT_rv_cdesc->shape[0];
    // splicer end function.return_int_ptr_to_fixed_const_array_bufferify
}
// end POI_return_int_ptr_to_fixed_const_array_bufferify

// ----------------------------------------
// Function:  int * returnIntScalar +deref(scalar)
// Attrs:     +deref(scalar)+intent(function)
// Exact:     c_function_native_*_scalar
// start POI_return_int_scalar
int POI_return_int_scalar(void)
{
    // splicer begin function.return_int_scalar
    int * SHC_rv = returnIntScalar();
    return *SHC_rv;
    // splicer end function.return_int_scalar
}
// end POI_return_int_scalar

/**
 * Call directly via interface.
 */
// ----------------------------------------
// Function:  int * returnIntRaw +deref(raw)
// Attrs:     +deref(raw)+intent(function)
// Requested: c_function_native_*_raw
// Match:     c_function_native_*
// start POI_return_int_raw
int * POI_return_int_raw(void)
{
    // splicer begin function.return_int_raw
    int * SHC_rv = returnIntRaw();
    return SHC_rv;
    // splicer end function.return_int_raw
}
// end POI_return_int_raw

/**
 * Like returnIntRaw but with another argument to force a wrapper.
 * Uses fc_statements f_function_native_*_raw.
 */
// ----------------------------------------
// Function:  int * returnIntRawWithArgs +deref(raw)
// Attrs:     +deref(raw)+intent(function)
// Requested: c_function_native_*_raw
// Match:     c_function_native_*
// ----------------------------------------
// Argument:  const char * name
// Attrs:     +intent(in)
// Requested: c_in_char_*
// Match:     c_default
// start POI_return_int_raw_with_args
int * POI_return_int_raw_with_args(const char * name)
{
    // splicer begin function.return_int_raw_with_args
    int * SHC_rv = returnIntRawWithArgs(name);
    return SHC_rv;
    // splicer end function.return_int_raw_with_args
}
// end POI_return_int_raw_with_args

/**
 * Test multiple layers of indirection.
 * # getRawPtrToInt2d
 */
// ----------------------------------------
// Function:  int * * returnRawPtrToInt2d
// Attrs:     +intent(function)
// Exact:     c_function_native_**
// start POI_return_raw_ptr_to_int2d
int * * POI_return_raw_ptr_to_int2d(void)
{
    // splicer begin function.return_raw_ptr_to_int2d
    int * * SHC_rv = returnRawPtrToInt2d();
    return SHC_rv;
    // splicer end function.return_raw_ptr_to_int2d
}
// end POI_return_raw_ptr_to_int2d

// ----------------------------------------
// Function:  int * returnIntAllocToFixedArray +deref(allocatable)+dimension(10)
// Attrs:     +deref(allocatable)+intent(function)
// Requested: c_function_native_*_allocatable
// Match:     c_function_native_*
// start POI_return_int_alloc_to_fixed_array
int * POI_return_int_alloc_to_fixed_array(void)
{
    // splicer begin function.return_int_alloc_to_fixed_array
    int * SHC_rv = returnIntAllocToFixedArray();
    return SHC_rv;
    // splicer end function.return_int_alloc_to_fixed_array
}
// end POI_return_int_alloc_to_fixed_array

// ----------------------------------------
// Function:  int * returnIntAllocToFixedArray +deref(allocatable)+dimension(10)
// Attrs:     +api(cdesc)+deref(allocatable)+intent(function)
// Requested: c_function_native_*_cdesc_allocatable
// Match:     c_function_native_*_cdesc
// start POI_return_int_alloc_to_fixed_array_bufferify
void POI_return_int_alloc_to_fixed_array_bufferify(
    POI_SHROUD_array *SHT_rv_cdesc)
{
    // splicer begin function.return_int_alloc_to_fixed_array_bufferify
    int * SHC_rv = returnIntAllocToFixedArray();
    SHT_rv_cdesc->cxx.addr  = SHC_rv;
    SHT_rv_cdesc->cxx.idtor = 0;
    SHT_rv_cdesc->addr.base = SHC_rv;
    SHT_rv_cdesc->type = SH_TYPE_INT;
    SHT_rv_cdesc->elem_len = sizeof(int);
    SHT_rv_cdesc->rank = 1;
    SHT_rv_cdesc->shape[0] = 10;
    SHT_rv_cdesc->size = SHT_rv_cdesc->shape[0];
    // splicer end function.return_int_alloc_to_fixed_array_bufferify
}
// end POI_return_int_alloc_to_fixed_array_bufferify

}  // extern "C"
