// wrapstruct.c
// This file is generated by Shroud nowrite-version. Do not edit.
// Copyright (c) 2017-2022, Lawrence Livermore National Security, LLC and
// other Shroud Project Developers.
// See the top-level COPYRIGHT file for details.
//
// SPDX-License-Identifier: (BSD-3-Clause)
//

// cxx_header
#include "struct.h"
// shroud
#include <string.h>
#include "wrapstruct.h"


// helper ShroudStrBlankFill
// blank fill dest starting at trailing NULL.
static void ShroudStrBlankFill(char *dest, int ndest)
{
   int nm = strlen(dest);
   if(ndest > nm) memset(dest+nm,' ',ndest-nm);
}
// splicer begin C_definitions
// splicer end C_definitions

/**
 * Pass name argument which will build a bufferify function.
 */
// ----------------------------------------
// Function:  int passStruct2
// Attrs:     +intent(function)
// Requested: c_function_native_scalar
// Match:     c_function
// ----------------------------------------
// Argument:  const Cstruct1 * s1
// Attrs:     +intent(in)
// Requested: c_in_struct_*
// Match:     c_in_struct
// ----------------------------------------
// Argument:  char * outbuf +charlen(LENOUTBUF)+intent(out)
// Attrs:     +api(buf)+intent(out)
// Exact:     c_out_char_*_buf
int STR_pass_struct2_bufferify(const Cstruct1 * s1, char *outbuf,
    int SHT_outbuf_len)
{
    // splicer begin function.pass_struct2_bufferify
    int SHC_rv = passStruct2(s1, outbuf);
    ShroudStrBlankFill(outbuf, SHT_outbuf_len);
    return SHC_rv;
    // splicer end function.pass_struct2_bufferify
}

/**
 * \brief Return a pointer to a struct
 *
 * Generates a bufferify C wrapper function.
 */
// ----------------------------------------
// Function:  Cstruct1 * returnStructPtr2
// Attrs:     +api(buf)+deref(pointer)+intent(function)
// Requested: c_function_struct_*_buf_pointer
// Match:     c_function_struct_*
// ----------------------------------------
// Argument:  int i +value
// Attrs:     +intent(in)
// Requested: c_in_native_scalar
// Match:     c_default
// ----------------------------------------
// Argument:  double d +value
// Attrs:     +intent(in)
// Requested: c_in_native_scalar
// Match:     c_default
// ----------------------------------------
// Argument:  char * outbuf +charlen(LENOUTBUF)+intent(out)
// Attrs:     +api(buf)+intent(out)
// Exact:     c_out_char_*_buf
Cstruct1 * STR_return_struct_ptr2_bufferify(int i, double d,
    char *outbuf, int SHT_outbuf_len)
{
    // splicer begin function.return_struct_ptr2_bufferify
    Cstruct1 * SHC_rv = returnStructPtr2(i, d, outbuf);
    ShroudStrBlankFill(outbuf, SHT_outbuf_len);
    return SHC_rv;
    // splicer end function.return_struct_ptr2_bufferify
}

// ----------------------------------------
// Function:  Cstruct_as_class * Create_Cstruct_as_class
// Attrs:     +api(capptr)+intent(function)
// Exact:     c_function_shadow_*_capptr
// start STR_create__cstruct_as_class
STR_Cstruct_as_class * STR_create__cstruct_as_class(
    STR_Cstruct_as_class * SHC_rv)
{
    // splicer begin function.create__cstruct_as_class
    Cstruct_as_class * SHCXX_rv = Create_Cstruct_as_class();
    SHC_rv->addr = SHCXX_rv;
    SHC_rv->idtor = 0;
    return SHC_rv;
    // splicer end function.create__cstruct_as_class
}
// end STR_create__cstruct_as_class

// ----------------------------------------
// Function:  Cstruct_as_class * Create_Cstruct_as_class_args
// Attrs:     +api(capptr)+intent(function)
// Exact:     c_function_shadow_*_capptr
// ----------------------------------------
// Argument:  int x +value
// Attrs:     +intent(in)
// Requested: c_in_native_scalar
// Match:     c_default
// ----------------------------------------
// Argument:  int y +value
// Attrs:     +intent(in)
// Requested: c_in_native_scalar
// Match:     c_default
STR_Cstruct_as_class * STR_create__cstruct_as_class_args(int x, int y,
    STR_Cstruct_as_class * SHC_rv)
{
    // splicer begin function.create__cstruct_as_class_args
    Cstruct_as_class * SHCXX_rv = Create_Cstruct_as_class_args(x, y);
    SHC_rv->addr = SHCXX_rv;
    SHC_rv->idtor = 0;
    return SHC_rv;
    // splicer end function.create__cstruct_as_class_args
}

// ----------------------------------------
// Function:  int Cstruct_as_class_sum
// Attrs:     +intent(function)
// Requested: c_function_native_scalar
// Match:     c_function
// ----------------------------------------
// Argument:  const Cstruct_as_class * point +pass
// Attrs:     +intent(in)
// Exact:     c_in_shadow_*
int STR_cstruct_as_class_sum(STR_Cstruct_as_class * point)
{
    // splicer begin function.cstruct_as_class_sum
    const Cstruct_as_class * SHCXX_point =
        (const Cstruct_as_class *) point->addr;
    int SHC_rv = Cstruct_as_class_sum(SHCXX_point);
    return SHC_rv;
    // splicer end function.cstruct_as_class_sum
}

// ----------------------------------------
// Function:  Cstruct_as_subclass * Create_Cstruct_as_subclass_args
// Attrs:     +api(capptr)+intent(function)
// Exact:     c_function_shadow_*_capptr
// ----------------------------------------
// Argument:  int x +value
// Attrs:     +intent(in)
// Requested: c_in_native_scalar
// Match:     c_default
// ----------------------------------------
// Argument:  int y +value
// Attrs:     +intent(in)
// Requested: c_in_native_scalar
// Match:     c_default
// ----------------------------------------
// Argument:  int z +value
// Attrs:     +intent(in)
// Requested: c_in_native_scalar
// Match:     c_default
STR_Cstruct_as_subclass * STR_create__cstruct_as_subclass_args(int x,
    int y, int z, STR_Cstruct_as_subclass * SHC_rv)
{
    // splicer begin function.create__cstruct_as_subclass_args
    Cstruct_as_subclass * SHCXX_rv = Create_Cstruct_as_subclass_args(x,
        y, z);
    SHC_rv->addr = SHCXX_rv;
    SHC_rv->idtor = 0;
    return SHC_rv;
    // splicer end function.create__cstruct_as_subclass_args
}

// ----------------------------------------
// Function:  const double * Cstruct_ptr_get_const_dvalue
// Attrs:     +api(buf)+deref(pointer)+intent(getter)+struct(Cstruct_ptr)
// Requested: c_getter_native_*_buf_pointer
// Match:     c_getter_native_*
// ----------------------------------------
// Argument:  Cstruct_ptr * SH_this
// Attrs:     +intent(in)+struct(Cstruct_ptr)
// Requested: c_in_struct_*
// Match:     c_in_struct
const double * STR_cstruct_ptr_get_const_dvalue_bufferify(
    Cstruct_ptr * SH_this)
{
    // splicer begin function.cstruct_ptr_get_const_dvalue_bufferify
    // skip call c_getter
    return SH_this->const_dvalue;
    // splicer end function.cstruct_ptr_get_const_dvalue_bufferify
}

// ----------------------------------------
// Function:  void Cstruct_ptr_set_const_dvalue
// Attrs:     +intent(setter)
// Exact:     c_setter
// ----------------------------------------
// Argument:  Cstruct_ptr * SH_this
// Attrs:     +intent(inout)+struct(Cstruct_ptr)
// Requested: c_inout_struct_*
// Match:     c_inout_struct
// ----------------------------------------
// Argument:  const double * val +intent(in)
// Attrs:     +intent(setter)
// Exact:     c_setter_native_*
void STR_cstruct_ptr_set_const_dvalue(Cstruct_ptr * SH_this,
    const double * val)
{
    // splicer begin function.cstruct_ptr_set_const_dvalue
    // skip call c_setter
    SH_this->const_dvalue = val;
    // splicer end function.cstruct_ptr_set_const_dvalue
}

// ----------------------------------------
// Function:  int * Cstruct_list_get_ivalue
// Attrs:     +api(cdesc)+deref(pointer)+intent(getter)+struct(Cstruct_list)
// Requested: c_getter_native_*_cdesc_pointer
// Match:     c_getter_native_*_cdesc
// ----------------------------------------
// Argument:  Cstruct_list * SH_this
// Attrs:     +intent(in)+struct(Cstruct_list)
// Requested: c_in_struct_*
// Match:     c_in_struct
void STR_cstruct_list_get_ivalue_bufferify(Cstruct_list * SH_this,
    STR_SHROUD_array *SHT_rv_cdesc)
{
    // splicer begin function.cstruct_list_get_ivalue_bufferify
    // skip call c_getter
    SHT_rv_cdesc->cxx.addr  = SH_this->ivalue;
    SHT_rv_cdesc->cxx.idtor = 0;
    SHT_rv_cdesc->addr.base = SH_this->ivalue;
    SHT_rv_cdesc->type = SH_TYPE_INT;
    SHT_rv_cdesc->elem_len = sizeof(int);
    SHT_rv_cdesc->rank = 1;
    SHT_rv_cdesc->shape[0] = SH_this->nitems+SH_this->nitems;
    SHT_rv_cdesc->size = SHT_rv_cdesc->shape[0];
    // splicer end function.cstruct_list_get_ivalue_bufferify
}

// ----------------------------------------
// Function:  void Cstruct_list_set_ivalue
// Attrs:     +intent(setter)
// Exact:     c_setter
// ----------------------------------------
// Argument:  Cstruct_list * SH_this
// Attrs:     +intent(inout)+struct(Cstruct_list)
// Requested: c_inout_struct_*
// Match:     c_inout_struct
// ----------------------------------------
// Argument:  int * val +intent(in)+rank(1)
// Attrs:     +intent(setter)
// Exact:     c_setter_native_*
void STR_cstruct_list_set_ivalue(Cstruct_list * SH_this, int * val)
{
    // splicer begin function.cstruct_list_set_ivalue
    // skip call c_setter
    SH_this->ivalue = val;
    // splicer end function.cstruct_list_set_ivalue
}

// ----------------------------------------
// Function:  double * Cstruct_list_get_dvalue
// Attrs:     +api(cdesc)+deref(pointer)+intent(getter)+struct(Cstruct_list)
// Requested: c_getter_native_*_cdesc_pointer
// Match:     c_getter_native_*_cdesc
// ----------------------------------------
// Argument:  Cstruct_list * SH_this
// Attrs:     +intent(in)+struct(Cstruct_list)
// Requested: c_in_struct_*
// Match:     c_in_struct
void STR_cstruct_list_get_dvalue_bufferify(Cstruct_list * SH_this,
    STR_SHROUD_array *SHT_rv_cdesc)
{
    // splicer begin function.cstruct_list_get_dvalue_bufferify
    // skip call c_getter
    SHT_rv_cdesc->cxx.addr  = SH_this->dvalue;
    SHT_rv_cdesc->cxx.idtor = 0;
    SHT_rv_cdesc->addr.base = SH_this->dvalue;
    SHT_rv_cdesc->type = SH_TYPE_DOUBLE;
    SHT_rv_cdesc->elem_len = sizeof(double);
    SHT_rv_cdesc->rank = 1;
    SHT_rv_cdesc->shape[0] = SH_this->nitems*TWO;
    SHT_rv_cdesc->size = SHT_rv_cdesc->shape[0];
    // splicer end function.cstruct_list_get_dvalue_bufferify
}

// ----------------------------------------
// Function:  void Cstruct_list_set_dvalue
// Attrs:     +intent(setter)
// Exact:     c_setter
// ----------------------------------------
// Argument:  Cstruct_list * SH_this
// Attrs:     +intent(inout)+struct(Cstruct_list)
// Requested: c_inout_struct_*
// Match:     c_inout_struct
// ----------------------------------------
// Argument:  double * val +intent(in)+rank(1)
// Attrs:     +intent(setter)
// Exact:     c_setter_native_*
void STR_cstruct_list_set_dvalue(Cstruct_list * SH_this, double * val)
{
    // splicer begin function.cstruct_list_set_dvalue
    // skip call c_setter
    SH_this->dvalue = val;
    // splicer end function.cstruct_list_set_dvalue
}
